      subroutine basist_3d(x,y,z,xo,yo,zo,nx,ny,nz,
     &         inodfa,planfa,ifatet,nktet,netet,kontet,field,nfield,
     &         cotet,nk,kontyp,ipkon,kon,iparent,co,field2,
     &         nka,nkb)
!
      implicit none
!
!     10 nearest nodes: node(10), idummy1(10),
!     idummy2(10),iparentel(10)
!
      integer ifatet(4,*),ibase,id,node(10),near,nx(*),ny(*),nz(*),
     &  nx1,ny1,nz1,isol,ifs,iface,i,ielnew,iout(4),konl(20),
     &  i1,i2,i3,nfield,nktet,ielement,ielmax,netet,nk,k,nout,
     &  irandom,j,kontet(4,*),inodfa(4,*),j1,j2,j3,j4,nsum,inode,
     &  kontyp(*),ipkon(*),kon(*),iparent(*),nterms,indexe,nelem,
     &  islavnode,konl_opt(20),idummy1(10),idummy2(10),iparentel(10),
     &  nparentel,kflag,ii,nka,nkb,isum,jj,inside
!
      real*8 cotet(3,*),planfa(4,*),dface,dfacemax,dd,tolerance,
     &  aa,dist,bb,p(3),field(nktet,nfield),vol,volume,
     &  ratio(20),pneigh(3,20),pnode(3),xi,et,ze,dist_opt,ratio_opt(20)
!
      real*8 a(3),b(3),p1(3),p2(3),p3(3),ba(3),pm(3),q(3),al,
     &  a1,a2,a3,a4,xp,yp,zp,x(*),y(*),z(*),xo(*),yo(*),zo(*),
     &  xpp,ypp,zpp,xpe(2),ype(2),zpe(2),xn,yn,zn,alambda,co(3,*),
     &  field2(nk,*)
!
      tolerance=1.d-6
!
      do jj=nka,nkb
         xp=co(1,jj)
         yp=co(2,jj)
         zp=co(3,jj)
!     
         do ii=1,2
!     
            if(ii.eq.1) then
               near=1
            else
               near=10
            endif
            call near_3d(xp,yp,zp,x,y,z,xo,yo,zo,nx,ny,nz,node,
     &           near,netet)
!     
            inside=0
!     
            do i=1,near
               ielement=node(i)
               dface=0.d0
               do j=1,4
                  ifs=ifatet(j,ielement)
                  iface=abs(ifs)
                  dist=planfa(1,iface)*xp+planfa(2,iface)*yp
     &                 +planfa(3,iface)*zp+planfa(4,iface)
                  if(dist*ifs.lt.-1.d-10*iface) then
                     dface=dface+dist*ifs/iface
                  endif
               enddo
               if(dface.gt.-1.d-10) then
                  inside=1
                  exit
               endif
               if(i.eq.1) then
                  dfacemax=dface
                  ielmax=ielement
               else
                  if(dface.gt.dfacemax) then
                     ielmax=ielement
                     dfacemax=dface
                  endif
               endif
            enddo
!     
!     if no element was found, the element with the smallest
!     dfacemax (summed distance) is taken 
!     
            if(inside.eq.0) then
               ielement=ielmax
            endif
!     
            nelem=iparent(ielement)
            if(kontyp(nelem).eq.1) then
               nterms=8
            elseif(kontyp(nelem).eq.2) then
               nterms=6
            elseif(kontyp(nelem).eq.3) then
               nterms=4
            elseif(kontyp(nelem).eq.4) then
               nterms=20
            elseif(kontyp(nelem).eq.5) then
               nterms=15
            elseif(kontyp(nelem).eq.6) then
               nterms=10
            else
               nterms=0
            endif
            indexe=ipkon(nelem)
!     
!     modify order of connectivity ccx <-> cgx
!     
            if(kontyp(nelem).eq.4) then
               do i=1,12
                  konl(i)=kon(indexe+i)
               enddo
               do i=13,16
                  konl(i+4)=kon(indexe+i)
               enddo
               do i=17,20
                  konl(i-4)=kon(indexe+i)
               enddo
            elseif(kontyp(nelem).eq.5) then
               do i=1,9
                  konl(i)=kon(indexe+i)
               enddo
               do i=10,12
                  konl(i+3)=kon(indexe+i)
               enddo
               do i=13,15
                  konl(i-3)=kon(indexe+i)
               enddo
            else
               do i=1,nterms
                  konl(i)=kon(indexe+i)
               enddo
            endif
!     
!     nodes of master element
!     
            do i=1,nterms
               do j=1,3
                  pneigh(j,i)=cotet(j,konl(i))
               enddo
            enddo
!     
!     slave node
!     
            pnode(1)=xp
            pnode(2)=yp
            pnode(3)=zp
!     
!     attaching slave node to master element
!     
            if(nterms.ne.0) then
               call attach_3d(pneigh,pnode,nterms,ratio,dist,xi,et,ze)
            endif
!     
!     checking the parent elements of the "best" tetrahedra
!     in case the distance between slave node and location of
!     interpolation exceeds "tolerance"
!     
c     write(*,*) 'ii,nelem,dist,tol ',ii,nelem,dist,tolerance
            if(dist.gt.tolerance) then
               do i=1,nterms
                  konl_opt(i)=konl(i)
                  ratio_opt(i)=ratio(i)
               enddo
               dist_opt=dist
!     
!     sorting the parent elements
!     
               do i=1,near
                  idummy1(i)=iparent(node(i))
               enddo
               kflag=1
               call isortii(idummy1,idummy2,near,kflag)
               nparentel=0
               do i=1,near
                  if(idummy1(i).eq.nelem) cycle
                  if(i.eq.1) then
                     iparentel(1)=idummy1(1)
                     nparentel=1
                  else
                     if(idummy1(i).ne.idummy1(i-1)) then
                        nparentel=nparentel+1
                        iparentel(nparentel)=idummy1(i)
                     endif
                  endif
               enddo
!     
               do k=1,nparentel
!     
!     slave node
!     
                  pnode(1)=xp
                  pnode(2)=yp
                  pnode(3)=zp
                  nelem=iparentel(k)
                  if(kontyp(nelem).eq.1) then
                     nterms=8
                  elseif(kontyp(nelem).eq.2) then
                     nterms=6
                  elseif(kontyp(nelem).eq.3) then
                     nterms=4
                  elseif(kontyp(nelem).eq.4) then
                     nterms=20
                  elseif(kontyp(nelem).eq.5) then
                     nterms=15
                  elseif(kontyp(nelem).eq.6) then
                     nterms=10
                  else
                     nterms=0
                  endif
                  indexe=ipkon(nelem)
!     
!     modify order of connectivity ccx <-> cgx
!     
                  if(kontyp(nelem).eq.4) then
                     do i=1,12
                        konl(i)=kon(indexe+i)
                     enddo
                     do i=13,16
                        konl(i+4)=kon(indexe+i)
                     enddo
                     do i=17,20
                        konl(i-4)=kon(indexe+i)
                     enddo
                  elseif(kontyp(nelem).eq.5) then
                     do i=1,9
                        konl(i)=kon(indexe+i)
                     enddo
                     do i=10,12
                        konl(i+3)=kon(indexe+i)
                     enddo
                     do i=13,15
                        konl(i-3)=kon(indexe+i)
                     enddo
                  else
                     do i=1,nterms
                        konl(i)=kon(indexe+i)
                     enddo
                  endif
!     
!     nodes of master element
!     
                  do i=1,nterms
                     do j=1,3
                        pneigh(j,i)=cotet(j,konl(i))
                     enddo
                  enddo
!     
!     attaching slave node to master element
!     
                  if(nterms.ne.0) then
                     call attach_3d(pneigh,pnode,nterms,ratio,dist,
     &                   xi,et,ze)
                  endif
!     
!     check whether the present element yields better results
!     
c     write(*,*) 'iter nelem,dist,tol ',nelem,dist,tolerance
                  if(dist.lt.dist_opt) then
                     do i=1,nterms
                        konl_opt(i)=konl(i)
                        ratio_opt(i)=ratio(i)
                     enddo
                     dist_opt=dist
                  endif
                  if(dist.lt.tolerance) exit
               enddo
!     
!     storing the optimal configuration
!     
               do i=1,nterms
                  konl(i)=konl_opt(i)
                  ratio(i)=ratio_opt(i)
               enddo
            endif
!     
            if((ii.eq.2).or.(dist.lt.tolerance)) exit
!     
         enddo
!     
!     interpolating the fields
!     
         do i=1,nfield
            field2(jj,i)=0.d0
            do j=1,nterms
               field2(jj,i)=field2(jj,i)+ratio(j)*field(konl(j),i)
            enddo
         enddo
!     
      enddo
!     
      return
      end
      
