/*     CALCULIX - A 3-dimensional finite element program                 */
/*              Copyright (C) 1998 Guido Dhondt                          */

/*     This program is free software; you can redistribute it and/or     */
/*     modify it under the terms of the GNU General Public License as    */
/*     published by the Free Software Foundation; either version 2 of    */
/*     the License, or (at your option) any later version.               */

/*     This program is distributed in the hope that it will be useful,   */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of    */ 
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the      */
/*     GNU General Public License for more details.                      */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program; if not, write to the Free Software       */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         */

#define Linux 1
#define IRIX 2
#define IRIX64 3
#define HP 4

#if ARCH == Linux
#define FORTRAN(A,B) A##_  B
#elif ARCH == IRIX || ARCH == IRIX64
#define FORTRAN(A,B) A##_##B
#elif ARCH == HP
#define FORTRAN(A,B) A##B
#endif

#define NNEW(a,b) (a *)u_calloc((b),sizeof(a))
#define RENEW(a,b,c) a=(b *) realloc((b *)(a),(c)*sizeof(b))


void FORTRAN(basist_3d,(double *x,
              double *y,double *z,double *xo,double *yo,double *zo,
              int *nx,int *ny,int *nz,
              int *inodfa,double *planfa,int *ifatet,int *nktet,
              int *netet,int *kontet,double *field,int *nfield,
	      double *cotet, int *nk, int *kontyp, 
              int *ipkon, int *kon, int *iparent,
              double *co, double *field2, int *nka, int *nkb));

void *basist_3dmt(void *i);

void FORTRAN(dsort,(double *x,int *nnx,int *netet,int *kflag));

void FORTRAN(generatetet,(int *kontet,int *ifatet,int *netet,
             int *inodfa,int *ifreefa,double *planfa,int *ipofa,
             int *nodes,double *cotet));

void FORTRAN(init,(int *nktet,int *inodfa,int *ipofa,int *netet_));

void FORTRAN(interpretinput,(char *buff,int *label,int *nk,int *longf,
             int *no,int *ne,int *nkon,int *nindex,int *nfield,
             int *ndfield,double *field,int *ipkon,int *kon,int *kontyp,
             double *co,int *iel));

void FORTRAN(isortii,(int *ix, int *iy, int *n, int *kflag));

void readinput(char *jobnamec, int *nk,
   int *ne, int *nfield, int **konp, int **ipkonp,
   int **kontypp, double **cop, double **fieldp, int **ielp,int *flag,
   char **inpc, int *nline, int **nop);

void *u_calloc(size_t num,size_t size);

void FORTRAN(writemesh,(int *kon,int *ne,double *co,int *nk,double *field2,
             int *nfield,char *inpc,int *nline,int *no,int *iel,int *ipkon,
             int *kontyp));

void FORTRAN(writetetmesh,(int *kontet,int *netet_,double *cotet,
     int *nktet, double *field, int *nfield));

