/*     CalculiX - A 3-dimensional finite element program                 */
/*              Copyright (C) 1998-2012 Guido Dhondt                          */

/*     This program is free software; you can redistribute it and/or     */
/*     modify it under the terms of the GNU General Public License as    */
/*     published by the Free Software Foundation(version 2);    */
/*                                                                       */

/*     This program is distributed in the hope that it will be useful,   */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of    */ 
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the      */
/*     GNU General Public License for more details.                      */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program; if not, write to the Free Software       */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         */

#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "interpol3d.h"

void readinput(char *jobnamec, int *nk,
   int *ne, int *nfield, int **konp, int **ipkonp,
   int **kontypp, double **cop, double **fieldp, int **ielp,int *flag,
   char **inpcp, int *nline, int **nop){

  /*   reads an frd file  */

  FILE *f1;

  char buff[1320], fninp[132]="",*inpc=NULL;

  int i,j,k,n,irestartread,irestartstep,ndfield,
      icntrl,nload,nforc,nboun,nmpc,nalset,nmat,ntmat,npmat,kflag=2,
      norien,nam,nprint,mint,ntrans,ncs,namtot,ncmat,memmpc,ne1d,
      ne2d,nflow,*meminset=NULL,*rmeminset=NULL, *inp=NULL,ntie,
      ithermal,nener,nstate,nentries=12,ifreeinp,ikey,lincludefn,
      nbody,*no=NULL,*kon=NULL,*ipkon=NULL,*kontyp=NULL,longf,nkon,
      *nindex=NULL,label=0,nk_,ne_,nkon_,nfield_,labelold=0,*iel=NULL,
      nline_; 

  double *co=NULL,*field=NULL;

  kon=*konp;
  ipkon=*ipkonp;
  kontyp=*kontypp;
  co=*cop;
  field=*fieldp;
  iel=*ielp;
  inpc=*inpcp;
  no=*nop;
   
  nk_=10000;
  ne_=10000;
  nkon_=200000;
  nfield_=6;
  nline_=100;
	  
  co=NNEW(double,3*nk_);
  no=NNEW(int,nk_);
  nindex=NNEW(int,nk_);
  ipkon=NNEW(int,ne_);
  kontyp=NNEW(int,ne_);
  iel=NNEW(int,ne_);
  kon=NNEW(int,nkon_);
  inpc=NNEW(char,132*nline_);

  *nk=0;
  *ne=0;
  *nfield=0;
  *nline=0;
  nkon=0;

  /* opening the input file */

  strcpy(fninp,jobnamec);
  if((f1=fopen(fninp,"r"))==NULL){
      printf("*ERROR in read: cannot open file %s",fninp);
      exit(0);
  }

  /* starting to read the input file */

  do{
      if(fgets(buff,1320,f1)==NULL){
	  fclose(f1);
	  break;
      }
	  
      /* storing the significant characters */
      /* get rid of blanks  */
	
      k=0;
      i=-1;
      do{
	  i++;
	  if((buff[i]=='\0')||(buff[i]=='\n')||(buff[i]=='\r')||(k==132)) break;
          buff[k]=buff[i];
	  k++;
      }while(1);
	
      /* check for blank lines and comments */

      if(k==0) continue;

      /* filling with blanks */
	  
      for(j=k;j<132;j++){
	  buff[j]=' ';
      }

      if((labelold<=2)&&(nk_==*nk)){
        nk_=(int)(1.1*nk_);
        RENEW(co,double,3*nk_);
        RENEW(no,int,nk_);
        RENEW(nindex,int,nk_);
      }
	  
      if((labelold<=3)&&(ne_==*ne)){
        ne_=(int)(1.1*ne_);
        RENEW(ipkon,int,ne_);
        RENEW(kontyp,int,ne_);
        RENEW(iel,int,ne_);
      }
	  
      if((labelold<=3)&&(nkon_<=nkon+19)){
        nkon_=(int)(1.1*nkon_);
        RENEW(kon,int,nkon_);
      }
	  
      if((labelold>3)&&(nfield_<=*nfield+5)){
        nfield_=*nfield+6;
        RENEW(field,double,nfield_**nk);
      }

      if((buff[1]!='-')||((buff[2]!='1')&&(buff[2]!='2'))){
	if(nline_==*nline){
	  nline_=(int)(1.1*nline_);
	  RENEW(inpc,char,132*nline_);
	}
	for(j=0;j<132;j++){
	  inpc[(*nline)*132+j]=buff[j];
	}
	(*nline)++;
      }

      FORTRAN(interpretinput,(buff,&label,nk,&longf,no,ne,&nkon,
              nindex,nfield,&ndfield,field,ipkon,kon,kontyp,co,iel));

      if((label>2)&&(labelold==2)){
        RENEW(co,double,3**nk);
        RENEW(no,int,*nk);
        RENEW(nindex,int,*nk);
        FORTRAN(isortii,(no,nindex,nk,&kflag));
      }

      if((label>3)&&(labelold==3)){
        RENEW(ipkon,int,*ne);
        RENEW(kontyp,int,*ne);
        RENEW(iel,int,*ne);
        RENEW(kon,int,nkon);
      }

      if((label==100)&&(labelold<100)){
	if(*flag==0){
	  break;
	}
	else{
	  field=NNEW(double,nfield_**nk);
	}
      }

      labelold=label;

  }while(1);

  RENEW(field,double,*nfield**nk);

  FORTRAN(isortii,(nindex,no,nk,&kflag));

  *konp=kon;
  *ipkonp=ipkon;
  *kontypp=kontyp;
  *cop=co;
  *fieldp=field;
  *ielp=iel;
  *inpcp=inpc;
  *nop=no;

  return;

}






