!
!     CalculiX - A 3-dimensional finite element program
!              Copyright (C) 1998-2012 Guido Dhondt
!
!     This program is free software; you can redistribute it and/or
!     modify it under the terms of the GNU General Public License as
!     published by the Free Software Foundation(version 2);
!     
!
!     This program is distributed in the hope that it will be useful,
!     but WITHOUT ANY WARRANTY; without even the implied warranty of 
!     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
!     GNU General Public License for more details.
!
!     You should have received a copy of the GNU General Public License
!     along with this program; if not, write to the Free Software
!     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
      subroutine writemesh(kon,ne,co,nk,field2,nfield,inpc,nline,
     &  no,iel,ipkon,kontyp)
!
      implicit none
!
      logical long
!
      character*1 c
      character*3 m1,m2,m3,m4,m5
      character*5 p0,p1,p2,p3,p4,p5,p6,p9999
      character*132 inpc(*)
!
      integer kon(*),ne,one,i,j,nsom,no(*),iel(*),ndfield,ictype,
     &  nk,index,node,kode,nfield,ipkon(*),kontyp(*),nline,iline,
     &  nfieldini,indexe,iexist,iformat
!
      real*8 co(3,*),field2(nk,*),time
!
!     output format: long
!
      iformat=1
!
      c='C'
!
      m1=' -1'
      m2=' -2'
      m3=' -3'
      m4=' -4'
      m5=' -5'
!
      p0='    0'
      p1='    1'
      p2='    2'
      p3='    3'
      p4='    4'
      p5='    5'
      p6='    6'
      p9999=' 9999'
!
      one=1
      kode=1
      time=0.d0
!
      iline=0
!
      open(7,file='interpolation.frd',status='unknown')
!
c      do i=1,nline
c         write(7,'(a132)') inpc(i)
c      enddo
c      write(7,*) ' stop '
      do
         iline=iline+1
C         write(7,'(a132)') inpc(iline)
         if(inpc(iline)(5:6).eq.'2C') then
             write(inpc(iline)(74:75),'(i2)') iformat
c            read(inpc(iline)(74:75),'(i2)') iformat
c            if(iformat.ne.0) then
               long=.true.
c            else
c               long=.false.
c            endif
            write(7,'(a132)') inpc(iline)
            exit
         endif
         write(7,'(a132)') inpc(iline)
      enddo
!
      if(long) then
         do i=1,nk
            write(7,100) m1,no(i),(co(j,i),j=1,3)
         enddo
      else
         do i=1,nk
            write(7,101) m1,no(i),(co(j,i),j=1,3)
         enddo
      endif
!
!     header of the elements
!
      do
         iline=iline+1
c         write(7,'(a132)') inpc(iline)
         if(inpc(iline)(5:6).eq.'3C') then
             write(inpc(iline)(74:75),'(i2)') iformat
c            read(inpc(iline)(74:75),'(i2)') iformat
c            if(iformat.ne.0) then
               long=.true.
c            else
c               long=.false.
c            endif
            write(7,'(a132)') inpc(iline)
            exit
         endif
         write(7,'(a132)') inpc(iline)
      enddo
!
!     storing the element topology
!
      if(long) then
         do i=1,ne
            indexe=ipkon(i)
            if(kontyp(i).eq.1) then
               write(7,102) m1,iel(i),p1,p0,p0
               write(7,104) m2,(no(kon(indexe+j)),j=1,8)
            elseif(kontyp(i).eq.2) then
               write(7,102) m1,iel(i),p2,p0,p0
               write(7,104) m2,(no(kon(indexe+j)),j=1,6)
            elseif(kontyp(i).eq.3) then
               write(7,102) m1,iel(i),p3,p0,p0
               write(7,104) m2,(no(kon(indexe+j)),j=1,4)
            elseif(kontyp(i).eq.4) then
               write(7,102) m1,iel(i),p4,p0,p0
               write(7,104) m2,(no(kon(indexe+j)),j=1,10)
               write(7,104) m2,(no(kon(indexe+j)),j=11,20)
            elseif(kontyp(i).eq.5) then
               write(7,102) m1,iel(i),p5,p0,p0
               write(7,104) m2,(no(kon(indexe+j)),j=1,10)
               write(7,104) m2,(no(kon(indexe+j)),j=11,15)
            elseif(kontyp(i).eq.6) then
               write(7,102) m1,iel(i),p6,p0,p0
               write(7,104) m2,(no(kon(indexe+j)),j=1,10)
            else
               write(*,*) '*ERROR in writemesh: unknown element type'
               stop
            endif
         enddo
      else
         do i=1,ne
            indexe=ipkon(i)
            if(kontyp(i).eq.1) then
               write(7,103) m1,iel(i),p1,p0,p0
               write(7,105) m2,(no(kon(indexe+j)),j=1,8)
            elseif(kontyp(i).eq.2) then
               write(7,103) m1,iel(i),p2,p0,p0
               write(7,105) m2,(no(kon(indexe+j)),j=1,6)
            elseif(kontyp(i).eq.3) then
               write(7,103) m1,iel(i),p3,p0,p0
               write(7,105) m2,(no(kon(indexe+j)),j=1,4)
            elseif(kontyp(i).eq.4) then
               write(7,103) m1,iel(i),p4,p0,p0
               write(7,105) m2,(no(kon(indexe+j)),j=1,15)
               write(7,105) m2,(no(kon(indexe+j)),j=16,20)
            elseif(kontyp(i).eq.5) then
               write(7,103) m1,iel(i),p5,p0,p0
               write(7,105) m2,(no(kon(indexe+j)),j=1,15)
            elseif(kontyp(i).eq.6) then
               write(7,103) m1,iel(i),p6,p0,p0
               write(7,105) m2,(no(kon(indexe+j)),j=1,10)
            else
               write(*,*) '*ERROR in writemesh: unknown element type'
               stop
            endif
         enddo
      endif
      iline=iline+1
      write(7,'(a132)') inpc(iline)
!
!     load cases
!
      nfieldini=0
      loop: do
!
!        header of the load cases
!
         ndfield=0
         do
            iline=iline+1
            if(inpc(iline)(1:3).eq.' -3') then
               exit
            endif
c            write(7,'(a132)') inpc(iline)
            if(inpc(iline)(1:5).eq.' 9999') then
               write(7,'(a132)') inpc(iline)
               exit loop
            endif
            if(inpc(iline)(3:6).eq.'100C') then
                 write(inpc(iline)(74:75),'(i2)') iformat
c               read(inpc(iline)(74:75),'(i2)') iformat
c               if(iformat.ne.0) then
                  long=.true.
c               else
c                  long=.false.
c               endif
            endif
            write(7,'(a132)') inpc(iline)
            if(inpc(iline)(1:3).eq.' -5') then
               read(inpc(iline)(19:23),'(i5)') ictype
               read(inpc(iline)(34:38),'(i5)') iexist
               if(iexist.ne.1) then
                  ndfield=ndfield+1
               endif
c               if(ictype.eq.1) then
c                  ndfield=ndfield+1
c               elseif(ictype.eq.2) then
c                  ndfield=ndfield+3
c               elseif(ictype.eq.4) then
c                  ndfield=ndfield+6
c               elseif(ictype.eq.12) then
c                  ndfield=ndfield+6
c               endif
            endif
         enddo
!
!     storing loads
!
         if(long) then
            do i=1,nk
               write(7,106) m1,no(i),(field2(i,j),j=nfieldini+1,
     &              nfieldini+ndfield)
            enddo
         else
            do i=1,nk
               write(7,107) m1,no(i),(field2(i,j),j=nfieldini+1,
     &              nfieldini+ndfield)
            enddo
         endif
         nfieldini=nfieldini+ndfield
         write(7,'(a132)') inpc(iline)
      enddo loop
!
      close(7)
!
 100  format(a3,i10,1p,3e12.5)
 101  format(a3,i5,1p,3e12.5)
 102  format(a3,i10,3a5)
 103  format(a3,i5,3a5)
 104  format(a3,10i10)
 105  format(a3,15i5)
 106  format(a3,i10,6e12.5)
 107  format(a3,i5,6e12.5)
!
      return
      end
